package com.smppw.analysis.domain.dao;

import com.smppw.analysis.domain.dataobject.CompanyInformationDo;
import com.smppw.analysis.domain.mapper.core.CompanyInformationDoMapper;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Component
public class CompanyInformationDao {
    private final CompanyInformationDoMapper companyInformationDoMapper;

    public CompanyInformationDao(CompanyInformationDoMapper companyInformationDoMapper) {
        this.companyInformationDoMapper = companyInformationDoMapper;
    }

    public List<CompanyInformationDo> listCompany(List<String> companyIds) {
        return this.companyInformationDoMapper.listCompany(companyIds);
    }

    public Map<String, String> getFundIdNameMap(List<String> companyIdList) {
        List<CompanyInformationDo> fundInformationDos = companyInformationDoMapper.listCompany(companyIdList);
        Map<String, String> fundIdNameMap = new HashMap<>();
        for (CompanyInformationDo fundInformationDo : fundInformationDos) {
            fundIdNameMap.put(fundInformationDo.getCompanyId(), fundInformationDo.getCompanyShortName());
        }
        return fundIdNameMap;
    }
}
