package com.smppw.analysis.domain.dao.nav;

import com.smppw.analysis.domain.dataobject.nav.MarketIndexesDo;
import com.smppw.analysis.domain.mapper.core.MarketIndexesDoMapper;
import com.smppw.common.pojo.dto.NavDto;
import com.smppw.common.pojo.enums.Frequency;
import com.smppw.constants.DateConst;
import com.smppw.utils.DateUtil;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Component(NavConstants.MARKET_INDEX_NAV)
public class MarketIndexDao extends AbstractNavDao<MarketIndexesDo> {
    private final MarketIndexesDoMapper marketIndexesDoMapper;

    public MarketIndexDao(MarketIndexesDoMapper marketIndexesDoMapper) {
        this.marketIndexesDoMapper = marketIndexesDoMapper;
    }

    @Override
    protected List<MarketIndexesDo> listSecNav(List<String> secIds, Integer curveTypeId, Integer strategyId, Map<String, Frequency> secFrequencyMap) {
        // todo
        return null;
    }

    @Deprecated
    public Map<String, List<NavDto>> getNav(List<String> indexIdList, String startDate, String endDate, boolean needUpdateAndCreateTime) {
        List<MarketIndexesDo> navDoList = marketIndexesDoMapper.listNavByTimeInterval(indexIdList, startDate, endDate, needUpdateAndCreateTime);
        return navDoListToNavDtoMap(navDoList);
    }

    /**
     * 领域对象集合转为数据传输对象集合
     *
     * @param navDoList 领域对象集合
     * @return 数据传输对象集合  key-基金ID  value-数据传输对象集合
     */
    @Deprecated
    private Map<String, List<NavDto>> navDoListToNavDtoMap(List<MarketIndexesDo> navDoList) {
        Map<String, List<NavDto>> fundIdNavDtoListMap = new HashMap<>();

        if (navDoList == null) {
            return fundIdNavDtoListMap;
        }

        for (MarketIndexesDo navDo : navDoList) {
            NavDto navDto = new NavDto();
            navDto.setFundId(navDo.getIndexId());
            if (navDo.getPriceDate() == null || navDo.getClose() == null) {
                continue;
            }
            navDto.setPriceDate(DateUtil.DateToString(navDo.getPriceDate(), DateConst.YYYY_MM_DD));
            navDto.setOriginalNav(navDo.getClose());
            navDto.setCumulativeNav(navDo.getClose());
            navDto.setCumulativeNavWithdrawal(navDo.getClose());
            if (navDo.getUpdatetime() != null) {
                navDto.setUpdatetime(DateUtil.DateToString(navDo.getUpdatetime(), DateConst.YYYY_MM_DD_HH_MM_SS));
            }
            if (navDo.getCreatetime() != null) {
                navDto.setCreatetime(DateUtil.DateToString(navDo.getCreatetime(), DateConst.YYYY_MM_DD));
            }

            if (fundIdNavDtoListMap.containsKey(navDo.getIndexId())) {
                List<NavDto> navDtoList = fundIdNavDtoListMap.get(navDo.getIndexId());
                navDtoList.add(navDto);
            } else {
                List<NavDto> navDtoList = new ArrayList<>();
                navDtoList.add(navDto);
                fundIdNavDtoListMap.put(navDo.getIndexId(), navDtoList);
            }
        }
        return fundIdNavDtoListMap;
    }

}
